Java异常处理之throw, throws,try和catch

版权声明:本文为博主原创文章,转载请标明出处。 https://blog.csdn.net/xx326664162/article/details/49637151

转载请标明出处:http://blog.csdn.net/xx326664162/article/details/49637151 文章出自:薛瑄的博客

你也可以查看我的其他同类文章,也会让你有一定的收货!

程序运行过程中可能会出现异常情况,比如被0除、对负数计算平方根等,还有可能会出现致命的错误,比如内存不足,磁盘损坏无法读取文件等,对于异常和错误情况的处理,统称为异常处理。

Java异常处理主要通过5个关键字控制:try、catch、throw、throws和finally。

  1. try 指它所包含的代码发生异常,则对其进行捕获;
  2. catch当有异常时抓住它,并进行相应的处理,使程序不受异常的影响而继续执行下去;
    catch语句的参数类似于方法的声明,包括一个异常类型和一个异常对象

    • 异常类型必须为Throwable类的子类,它指明了catch语句处理的异常类型,
    • 异常对象则由运行时系统在try所指定的代码块中生成并被捕获,在catch中处理异常对象。

    • catch语句可以有多个,分别处理不同类的例外。Java运行时从上到下分别对每个catch语句处理的异常类型进行检测,直到找到类型相匹配的catch语句为止。这里,类型匹配指catch处理的异常类型与生成的异常对象的类型一致或者是它的父类,因此,catch语句的排列顺序应该是从特殊到一般。

    • 可以用一个catch语句处理多个异常类型,这时它的异常类型参数应该是这多个异常类型的父类,程序设计中要根据具体的情况来选择catch语句的例外处理类型。

  3. throw是在程序中明确引发异常,;
  4. throws的作用是如果一个方法可以引发异常,而它本身并不对该异常处理,那么它必须将这个异常抛给调用它的方法;
  5. finally是无论发不发生异常都要被执行的代码
 package book.exception;
/** */

public class ThrowAndThrows {
    /**
     * 计算一个数字的平方根
     * @param nStr    以字符串的形式提供数字
     * @return    返回平方根
     * @throws Exception    当用户输入的字符串为空,
     * 或者字符串无法转换成数字,或者转换成的数字小于0,都会抛出异常
     */
    public static double sqrt(String nStr) throws Exception {
        if (nStr == null) {
            //用trow关键字抛出异常,当异常被抛出时,程序会跳出该方法
            throw new Exception("输入的字符不能为空!");
        }
        double n = 0;
        try {
            n = Double.parseDouble(nStr);
        } catch(NumberFormatException e) {
            //将parseDouble方法可能抛出的异常NumberFormatException捕获,
            //然后将捕获的异常重新封装并输出
            throw new Exception("输入的字符串必须能够转化成数字!", e);
        }
        if (n < 0 ){
            throw new Exception("输入的字符串转化成的数字必须大于0!");
        }
        return Math.sqrt(n);
    }

    public static void main(String[] args) throws Exception {
        try{
            ThrowAndThrows.sqrt("-124.56");
        } catch(Exception e) {
            //将sqrt方法声明的可能抛出的Exception异常捕获
            System.out.println("Got a Exception:" + e.getMessage());
            //打印捕获的异常的堆栈信息,从堆栈信息中可以发现异常发生的位置和原因

            e.printStackTrace();
            throw e;    //不做进一步处理,将异常向外抛出
        }

        //将sqrt声明了可能会抛出的异常向外抛出,必须在方法声明中使用throws
        ThrowAndThrows.sqrt("-124.56");
    }

}

程序输出结果:

Got a Exception:输入的字符串转化成的数字必须大于0java.lang.Exception: 输入的字符串转化成的数字必须大于0!
    at book.exception.ThrowAndThrows.sqrt(ThrowAndThrows.java:30)
    at book.exception.ThrowAndThrows.main(ThrowAndThrows.java:37)
Exception in thread "main" java.lang.Exception: 输入的字符串转化成的数字必须大于0!
    at book.exception.ThrowAndThrows.sqrt(ThrowAndThrows.java:30)
    at book.exception.ThrowAndThrows.main(ThrowAndThrows.java:37)

源码分析:
在main方法里,由于sqrt方法的声明中有throws关键字,所以,在调用该方法时,必须对throws后面声明的异常进行处置,处置的方法有两种:

  1. main方法处理该异常,使用try…..catch语句,将可能会出现的异常的代码放在try块内,将处理异常的代码放在catch块内,并指明catch能够捕获的异常的类型,当异常被捕获时,执行catch块内的语句。

  2. main方法不处理该异常,将异常向外层程序抛出。在方法声明中使用throws关键字抛出异常,方法体中不需要使用try…catch语句。

异常类Exception的getMessage方法用来获取一场的描述信息,printStackTrace方法用来打印异常的堆栈信息,通过堆栈信息能够查明异常发生的原因和位置,在调试的时候常用。

参考:http://blog.csdn.net/ronawilliam/article/details/3299676
http://blog.csdn.net/zhouyong80/article/details/1907799

关注我的公众号,轻松了解和学习更多技术
这里写图片描述

阅读更多

扫码向博主提问

薛瑄

博客专家

加QQ群825637320 免费提问
  • 擅长领域:
  • android
  • java
  • spring boo
  • spring clo
  • linux
去开通我的Chat快问
想对作者说点什么?

博主推荐

换一批

没有更多推荐了,返回首页